#ifndef pqOptUMesh_h
#define pqOptUMesh_h

#include "pqPropertyWidget.h"

#include <iostream>
#include <cstdlib>
#include <cstring>
#include <sstream>
#include <string>
#include <vector>

#include <QWidget>
#include <QString>
#include <QLineEdit>
#include <QComboBox>
#include <QString>

//-----------------------------------------------------------------------------

class pqOptUMesh : public pqPropertyWidget
{
  Q_OBJECT
  typedef pqPropertyWidget Superclass;

public:
  pqOptUMesh(
    vtkSMProxy* smproxy, vtkSMProperty* smproperty, QWidget* parentObject = 0);
  virtual ~pqOptUMesh();

protected:
  bool* meshGenComplete;
  bool* goodDocker;

  int flowIterationsValue;

  std::string rootPath;
  std::string preProcessFile;
  std::string meshGenLog;
  std::string* pyGuiPath;

  QString* caseFileDir;
  QStringList surfacePaths;

  QLineEdit* blockMeshCells;

protected slots:
  void aboutMessage();
  void caseFileHandler();
  void dockerMessage();
  void selectSurface();
  std::string writePreProcessing();
  void controlDict(std::string);
  void blockMeshDict(std::string);
  void snappyHexMeshDict(std::string);
  void generateMesh();

private:
  Q_DISABLE_COPY(pqOptUMesh)
};

#endif
